package com.izouma.nineth.service;

import com.anji.captcha.service.CaptchaCacheService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.redis.core.StringRedisTemplate;
import org.springframework.stereotype.Service;

import java.util.concurrent.TimeUnit;

/**
 * 对于分布式部署的应用，我们建议应用自己实现CaptchaCacheService，比如用Redis，参考service/spring-boot代码示例。
 * 如果应用是单点的，也没有使用redis，那默认使用内存。
 * 内存缓存只适合单节点部署的应用，否则验证码生产与验证在节点之间信息不同步，导致失败。
 *
 * ☆☆☆ SPI： 在resources目录新建META-INF.services文件夹(两层)，参考当前服务resources。
 * @Title: 使用redis缓存
 * @author lide1202@hotmail.com
 * @date 2020-05-12
 */
@Service("AjCaptchaCacheService")
public class CaptchaCacheServiceRedisImpl implements CaptchaCacheService {

    private String captchKeyPrefix = "captchaKey::";

    @Override
    public String type() {
        return "redis";
    }

    @Autowired
    private StringRedisTemplate stringRedisTemplate;

    private String genKey(String key){
        return captchKeyPrefix + key;
    }


    @Override
    public void set(String key, String value, long expiresInSeconds) {
        String realKey = genKey(key);
        stringRedisTemplate.opsForValue().set(realKey, value, expiresInSeconds, TimeUnit.SECONDS);
    }

    @Override
    public boolean exists(String key) {
        String realKey = genKey(key);
        return stringRedisTemplate.hasKey(realKey);
    }

    @Override
    public void delete(String key) {
        String realKey = genKey(key);
        stringRedisTemplate.delete(realKey);
    }

    @Override
    public String get(String key) {
        String realKey = genKey(key);
        return stringRedisTemplate.opsForValue().get(realKey);
    }

	@Override
	public Long increment(String key, long val) {
        String realKey = genKey(key);
        return stringRedisTemplate.opsForValue().increment(realKey, val);
	}


}
